package board;

import engine.Constants;

/**
 * Used for bootstrapping forced wins\losses
 *
 */
public class BoardFoursOnly extends Board {
	
	public double[] getFeatureVector() {
		count();
		return new double[]{
			fours[ME],
			fours[OPP]
		};
	}

	private int[] fours = new int[3];
	public double[] weights = {1,-1};
	
	protected void count() {
		fours[0] = fours[1] = 0;
		int[][] directions = {{0,1},{1,0},{1,1},{-1,1}};
		int i=0;
		while (i < directions.length && fours[0]==0 && fours[1]==0) {
			countInDirection(directions[i][0], directions[i][1]);
			++i;
		}
	}

	private void countInDirection(int xshift, int yshift) {
		int colMin = xshift == -1 ? 3 : 0,
			colMax = Constants.nCols - (xshift == 1 ? 3 : 0),
			rowMax = Constants.nRows-3*yshift, g1,g2,g3,g4;
			for(int col=colMin; col<colMax; ++col) {
				for(int row=0; row<rowMax; ++row) {
					g1 = grid[row][col];
					g2 = grid[row+yshift][col+xshift];
					g3 = grid[row+yshift*2][col+xshift*2];
					g4 = grid[row+yshift*3][col+xshift*3];
					if (g1!=EMPTY&&g1==g2&&g2==g3&&g3==g4) {
						++fours[g1];
						return;
					}
			}
		}
	}

	public int winner() {
		
		count();
		if (fours[0]+fours[1] > 0) {
			return fours[ME] > 0 ? 0 : 1;
		}
		
		if (moves.size() == Constants.nCols*Constants.nRows) // is full
			return 2; //tie
		
		return -1;
	}
	
}