package board;


public class BoardSimple extends BoardCount {

	public double[] getFeatureVector() {
		count();
		return new double[]{
				singles.getCount()[0][0],
				fours.getCount()[0][0],
				singles.getCount()[1][0],
				fours.getCount()[1][0]
		};
	}

	/**
	 * 
	 * @return counter of singles split by the game time 
	 */
	protected Counter getSinglesCounter() {
		return new Counter() {
			{ n = new double[2][1]; } // split by game time
			@Override
			public void count(int firstEmptyPosition, int xshift, int yshift, int startCol, int startRow) {
				if (players[BoardCount.OPP]+players[BoardCount.ME]==0) return;

				if (players[BoardCount.OPP]==0) // potential winning configuration for me
					++n[0][0];
				if (players[BoardCount.ME]==0) // potential winning configuration for the opponent
					++n[1][0];
			}
		};
	}

	protected Counter getDoublesCounter() {
		return getDummyCounter();
	}

	protected Counter getTriplesCounter() {
		return getDummyCounter();
	}

}
