package runtime;

import java.util.List;

import board.Board;
import board.BoardCount;
import engine.Constants;
import engine.DeciderEpsilonGreedy;
import engine.ExploitExplore;

public class SarsaAgent implements player.gamer.statemachine.sadna.FourInARow {

	private ExploitExplore nextMoveDecider = new DeciderEpsilonGreedy(Constants.maxDepthPlaying, Constants.maxDepthPlaying);
	private double[] weights,
					weightsFirstPlayer = {0.022572888329052257, 0.013763954437813362, 0.02556224908169457, 0.026974617047168303, 7.92798137215922, -0.03132091731566117, -0.013013859197106115, -0.014462442806950885, -0.02821997614732457, -7.4566506423620815},
					weightsSecondPlayer = {0.019914734394436785, 0.05408377761880093, 0.037160208358647556, 0.049570069272707885, 7.344240033588715, -0.022981866125166936, -0.0567515185119592, -0.028060661824501086, -0.05870453037270598, -7.5048236284654255};
	private Board board = new BoardCount();
	
	@Override
	public void fourStart(String role) {
		board.clear();
		weights = role.equals("red") ? weightsFirstPlayer : weightsSecondPlayer;
	}
	
	@Override
	public int fourMove(List<Integer> moved, List<Integer> options, long timelimit) {

		if (moved.size()>0)
			board.setMove(moved.get(0)-1, true);
		
		timelimit -= System.currentTimeMillis();
		//TODO:
		//nextMoveDecider.setMaxDepth(f(timelimit));
		
		int move = options.size() > 1 ? nextMoveDecider.getNextMove(board, weights, 1) : options.get(0)-1;
		board.setMove(move, false);

		return options.indexOf(move+1);
	}
	
	@Override
	public void fourEnd(int score) {
	}
	
	@Override
	public String getName() {
		return "MeravLior";
	}

}